%{?nodejs_find_provides_and_requires}

%global packagename typescript

%global enable_tests 0
# Tests disabled due to missing npm(tslint) dependency, which depends on this
# package

%global bootstrap 1
# Bootstrapping enabled to use pre-compiled sources until we can bootstrap the
# dependencies, in order to build from the typescript source

Name:		nodejs-typescript
Version:	1.8.2
Release:	1%{?dist}
Summary:	TypeScript is a language for application scale JavaScript development

License:	ASL 2.0
URL:		https://github.com/Microsoft/TypeScript.git
Source0:	https://registry.npmjs.org/%{packagename}/-/%{packagename}-%{version}.tgz
# The test files are not included in the npm tarball.
# Sources 1-9 are generated by running Source10, which pulls from the upstream
# version control repository.
Source1:	tests-%{version}.tar.bz2
Source2:	src-%{version}.tar.bz2
Source3:	scripts-%{version}.tar.bz2
Source4:	docs-%{version}.tar.bz2
Source10:	dl-tests.sh
#Jakefile
Source11:	https://raw.githubusercontent.com/Microsoft/TypeScript/v%{version}/Jakefile.js


BuildArch:	noarch
%if 0%{?fedora} >= 19
ExclusiveArch: %{nodejs_arches} noarch
%else
ExclusiveArch: %{ix86} x86_64 %{arm} noarch
%endif

BuildRequires:	nodejs-packaging
%if 0%{?enable_tests}
BuildRequires:	jake
%endif

%description
TypeScript is a language for application scale JavaScript development


%prep
%setup -q -n package
# setup the tests
%setup -q -T -D -a 1 -n package
%setup -q -T -D -a 2 -n package
%setup -q -T -D -a 3 -n package
%setup -q -T -D -a 4 -n package
# Jakefile
cp -p %{SOURCE11} .


%build
%if !0%{bootstrap}
   %nodejs_symlink_deps --build
   jake
   rm -rf ./node_modules
%endif

%install
mkdir -p %{buildroot}%{nodejs_sitelib}/%{packagename}
cp -pr package.json lib/ \
	%{buildroot}%{nodejs_sitelib}/%{packagename}

mkdir -p %{buildroot}%{nodejs_sitelib}/%{packagename}/bin
install -p -D -m0755 bin/tsc %{buildroot}%{nodejs_sitelib}/%{packagename}/bin/tsc
install -p -D -m0755 bin/tsserver %{buildroot}%{nodejs_sitelib}/%{packagename}/tsserver

mkdir -p %{buildroot}%{_bindir}
ln -sf %{nodejs_sitelib}/%{packagename}/bin/tsc %{buildroot}%{_bindir}/tsc
ln -sf %{nodejs_sitelib}/%{packagename}/bin/tsserver %{buildroot}%{_bindir}/tsserver

%nodejs_symlink_deps

%check
%nodejs_symlink_deps --check
%{__nodejs} -e 'require("./")'
%if 0%{?enable_tests}
%{_bindir}/jake runtests
%else
%{_bindir}/echo -e "\e[101m -=#=- Tests disabled -=#=- \e[0m"
%endif


%files
%{!?_licensedir:%global license %doc}
%doc *.md doc/
%license LICENSE.txt
%{nodejs_sitelib}/%{packagename}
%{_bindir}/tsc
%{_bindir}/tsserver


%changelog
* Thu Feb 25 2016 Jared Smith <jsmith@fedoraproject.org> - 1.8.2-1
- Initial packaging
